#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<getopt.h>
#include<unistd.h>
#include"stree.h"
#include"tree_hdl.h"
#include"file_hdl.h"

static char *prog_name;

void mem_error()
{
  printf("Out of Memory!");
  exit(0);
}

void usage()
{
  printf("usage: %s -c|-f textfile.txt -p pattern [-s] [-h]\n",prog_name);
}

int main(int argc, char *argv[])
{
  char opt,show_tree=0;
  st_meta data;

  prog_name=argv[0];

  memset(&data,0,sizeof(st_meta));

  while((opt=getopt(argc,argv,"hsc:f:p:"))!=EOF) {
    switch(opt) {
    case 'c':
      data.use_mode='c';
    case 'f':
      if(data.use_mode==0) {
	data.use_mode='f';
      }
      strncpy(data.fname,optarg,255);
      data.fname[255]=0;
      break;
    case 'p':
      data.pattern=malloc(strlen(optarg)+1);
      if(data.pattern==NULL) {
	mem_error();
      }
      strcpy((char*)data.pattern,optarg);
      break;
    case 's':
      show_tree=1;
      break;
    case 'h':
      usage();
      return 1;
    }
  }
  if(strlen(data.fname)==0) {
    usage();
    return 1;
  }

  if(init_files(&data)!=0) {
    fprintf(stderr,"Couldn't find proper index!\n");
    return 2;
  }

  if(data.use_mode=='c') {
    create_stree(&data);
  }
  if(show_tree!=0) {
    print_tree(&data);
  }
  if(data.use_mode=='c') {
    save_tree(&data);
  } else if(data.pattern!=NULL && strlen((char*)data.pattern)>0) {
    stree_find(&data);
  }

  return 0;

} 

