#ifndef _TREE_HDL_H_
#define _TREE_HDL_H_

#include "stree.h"

/* Returns transition from here with transId==t, NULL if not found. O(long S)*/
st_trans *get_transition(st_meta *sm, st_node *here, byte t);

/* Prints the suffixtree. */
void print_tree(st_meta *sm);

/* Insert transition this to correct location in node here. Returns NULL if
   out of memory, pointer to the inserted transition otherwise */
st_trans *insert_transition(st_meta *sm, st_node *here, st_trans *this);

/* Print the whole suffix tree. */
void print_tree(st_meta *sm);

#endif
